#this class maintains a tabu list and kicks elements out if they are too old
class Tabu

  def initialize(size)
    @hash = {}
    @max = size
  end

  #decrease longevity of all keys and insert new one
  def insert(elem)
    @hash.each_key do |key|
      @hash[key] -= 1
      if @hash[key] <= 0
        @hash.delete(key)
      end
    end
    @hash[elem] = @max
  end

  def include?(elem)
    !@hash[elem].nil?
  end
end
